def fn set_colours% (force_mode%)
rem this sets colour variables according to the colour mode wished, if possible.
rem force_mode%=
rem	0 if ql colours wished (mode 4 only)
rem	1 if pal colours wished
rem	2 if 24 bit colours wished
rem This function returns the true QL mode set (4,8,32,33 etc.).
rem This function also sets the GLOBAL variable mycolour_mode% to the
rem mode 0,1,2 as above - whatever is possible on the machine, i.e.
rem if colour_24 is wished on a 4 colour machine (which won't succeed)
rem this function will set set that variable to 0, i.e. QL mode.
rem
rem This function needs the outptr toolkit
local mode%
  mode%=rmode				: rem get current mode now
  select on force_mode%
      = 0				: rem mode 4 wished
       select on mode%
	  = 4				: rem already on, so do nothing
	  = 0,1,8 : mode 4		: rem old modes, set to 4 colours
	  = remainder
	    colour_ql			: rem if higher colour mode, set to "mode 4"
	    mode 4
       end select
       mode%=0				: rem new mode we're in  - 4 colour mode
      = 1				: rem PALette wished
       select on mode%
	  = 16,32,33 : colour_pal:mode%=1  : rem we're in high colour mode, but PAL colours wished
	  = remainder
	    if mode%<>4:mode 4
	    mode%=0
       end select
      = 2
       select on mode%
	  = 32,33 : colour_24 :mode%=2	: rem we're in high col mode 24 bit colours
	  = 16 : colour_pal : mode%=1
	  = remainder
	    if mode%<>4:mode 4
	    mode%=0
       end select
  end select
  mycolour_mode%=mode%			: rem set this global variable now:
  rem now set some colour variables
  select on mode%
       = 0				: rem Ql 4 mode colours
	Black	       = 0
	White	       = 7
	Red	       = 2
	Green	       = 4
	wg_striped     = 92
	br_striped     = 82
	wr_striped     = 107
	bg_striped     = 100
       = 1			: rem Colour_pal
	Black	       = 0
	White	       = 1
	Red	       = 2
	Green	       = 3
	wg_striped     = light_green
	br_striped     = dark_red
	wr_striped     = light_red
	bg_striped     = dark_green
       = 2			: rem colour_24
	Black	       = hex('000000')
	White	       = hex('FFFFFF')
	Red	       = hex('FF0000')
	Green	       = hex('00FF00')
	wg_striped     = light_green
	br_striped     = dark_red
	wr_striped     = light_red
	bg_striped     = dark_green
  end select
  mode%=rmode
  ret mode%			: rem return current screen mode now
end def set_colours%
:
